#include "RegisterAllocator.h"
#include "BasicBlock.h"
#include "setOverloads.h"

void RegisterAllocator::analyseLive() {
	for (auto v : vars) {
		for (auto q : v->uses) {
			q->block->flow.use.emplace(v);
		}
		for (auto q : v->writes) {
			q->block->flow.def.emplace(v);
		}
	}
	for (const auto& b : blocks) {
		for (const auto& phiMap : b->phi) {
			for (const auto& phiRow : phiMap) {
				b->flow.def.emplace(phiRow.first);
				b->flow.use.emplace(phiRow.second);
			}
		}
	}

	while (true) {
		bool changed = false;
		for (const auto& b : blocks) {
			set<VariablePtr> pIn, pOut, diff;
			auto &f = b->flow;
			pIn.swap(f.in);
			pOut.swap(f.out);
			f.in = f.use + (pOut - f.def);
			for (const auto& succ : b->out) {
				f.out += succ->flow.in;
			}
			if (f.in != pIn || f.out != pOut) changed = true;
		}
		if (!changed) break;
	}
}