#ifndef ZAD2_REGISTERALLOCATOR_H
#define ZAD2_REGISTERALLOCATOR_H

#include <utility>

#include "Quadruple.h"
#include "QuadrupleGenerator.h"

class Register : public std::enable_shared_from_this<Register> {
	bool available;
	set<VariablePtr> contains;
	std::string name;
};

class RegisterAllocator {
public:
	RegisterAllocator(const QuadrupleGenerator::Result &r) : blocks(r.blocks), vars(r.vars) {}
	void processQJump(shared_ptr<QJump> q);
	void processQJumpCond(shared_ptr<QJumpCond> q);
	void processQLabel(shared_ptr<QLabel> q);
	void processQParam(shared_ptr<QParam> q);
	void processQReturn(shared_ptr<QReturn> q);
	void processQWrite(shared_ptr<QWrite> q);
	void processQAccess(shared_ptr<QAccess> q);
	void processQAlloc(shared_ptr<QAlloc> q);
	void processQAssign(shared_ptr<QAssign> q);
	void processQCall(shared_ptr<QCall> q);

	void analyseLive();
private:
	vector<BasicBlockPtr> blocks;
	vector<VariablePtr> vars;
};


#endif //ZAD2_REGISTERALLOCATOR_H
